<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Selection Sort Experiment</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8"/>
        <style>
         .exp {
             display: none;
         }
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }
         th {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         #headings {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height:20px;
         }
         tr:hover {
             background-color: #ddd;
         }
        </style>
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'Selection Sort',
          'expShortName': 'selection-sort'
          });


          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->
    </head>
    <body>
      <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
      </noscript>
      <div class="exp" title="Selection Sort Experiment">
            <div class="longt">
                <h1 class="hlongt"> Introduction to Selection Sort</h1>
            </div>
            <div class="preamble">
                <div class="art txt" title="Estimation">
                    <div class="longt">
                        <h2 class="hlongt">Estimated Time</h2>
                    </div>
                    <div class="art-body">
                        <p>1.5 hour</p>
                    </div>
                </div>
                <div class="art req" title="Selection Sort Introduction">
                    <div class="longt">
                        <h2 class="hlongt">Introduction</h2>
                    </div>
                    <div class="description">
                        <p> Introduction video for Selection Sort</p>
                    </div>
                </div>
                <div class="art txt" title="Prerequisites">
                    <div class="longt">
                        <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>
                            This experiment requires you to have basic knowledge about :
                        </p>
                        <ul>
                            <li><a href="https://en.wikipedia.org/wiki/Sorting_algorithm">The Notion of Sorting</a></li>
                            <li><a href="https://en.wikipedia.org/wiki/Time_complexity">Notion of Time and Space complexity</a></li>
                        </ul>
                        <p>And above all, a curiosity to learn and explore!</p>
                    </div>
                </div>
                <div class="art txt" title="Overview">
                    <div class="longt">
                        <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <ul>
                            <li>
                                The aim of this experiment
                                is to understand the
                                Selection Sort algorithm,
                                its Time and Space
                                Complexity, and how it
                                compares against other
                                sorting algorithms.
                            </li>
                            <li>
                                The experiment features a
                                series of modules with video
                                lectures, interactive
                                demonstrations, simulations,
                                hands-on practice exercises
                                and quizzes for self
                                analysis.
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="art txt" title="Learning Objectives">
                    <div class="longt">
                        <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>In this experiment, we will learn about:</p>
                            <ul>
                                <li>Given an unsorted array of
                                    numbers, generate a sorted array
                                    of numbers by applying Selection Sort
                                </li>
                                <li>Demonstrate knowledge of time
                                    complexity of Selection Sort by
                                    counting the number of
                                    operations involved in each iteration.
                                </li>
                                <li>Compare Selection Sort
                                    with other sorting
                                    algorithms and realise
                                    Selection Sort as a stable
                                    comparison sorting
                                    algorithm.
                                </li>
                            </ul>
                    </div>
                </div>
                <div class="art txt" title="Modules and Weightage">
                    <div class="longt">
                        <h2 class="hlongt">Experiment Modules & their Weightage</h2>
                    </div>
                    <div class="art-body">
                        <table>
                            <thead>
                                <tr>
                                    <th style="text-align:center">Module</th>
                                    <th style="text-align:center">Weightage</th>
                                    <th style="text-align:center">Expectation</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>Pre-test</td>
                                    <td>15%</td>
                                    <td>Solve All Questions</td>
                                </tr>
                                <tr>
                                    <td>Selection Sort</td>
                                    <td>35%</td>
                                    <td>Understand the Selection sort algorithm</td>
                                </tr>
                                <tr>
                                    <td>Analysis</td>
                                    <td>25%</td>
                                    <td>Understand the time and space complexity</td>
                                </tr>
                                <tr>
                                    <td>Post-test</td>
                                    <td>25%</td>
                                    <td>Solve all Questions</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="lu" title="Pre-test">
                <div class="longt" >
                    <h1 class="hlongt">Pre-test of the Experiment</h1>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Pre-Test</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>Pretest includes questions on
                                    <strong>sorting, time
                                    complexity and space
                                    complexity.</strong>
                                </li>  
                                <li>If you want to
                                    revise these topics
                                    before taking the quiz,
                                    go through the Recap
                                    module first.
                                </li>
                                <li>Read the questions in
                                    the quiz section and select the
                                    correct option from the ones
                                    provided. Please note that some
                                    <strong>questions
                                        may have more than
                                        one correct
                                        response.
                                    </strong>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="task" title="Recap">
                    <div class="longt">
                        <h2 class="hlongt">Quick look at Sorting, Time and Space Complexity</h2>
                    </div>
                    <div class="art txt" title="Sorting">
                        <div class="longt">
                            <h2 class="hlongt">What is Sorting?</h2>
                        </div>
                        <div class="art-body">
                            <p>Given a list of random
                               numbers, sorting means
                               <b>ordering</b> the numbers
                               in either ascending or
                               descending order.  By
                               default, we sort numbers in
                               an ascending order.
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Sorting Visualization">
                        <div class="longt">
                            <h2 class="hlongt">Unsorted and Sorted arrays</h2>
                        </div>
                        <div class="description">
                            <p>Picture shows sorted and unsorted array.</p>
                        </div>
                    </div>
                    <div class="art txt" title="Time and Space Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Time and Space Complexity</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                               <li>
                               Time complexity of an
                               algorithm gives the measure
                               of time taken by it to run as
                               a function of the length of
                               the input. Similarly, Space
                               complexity of an algorithm
                               quantifies the amount of
                               space or memory taken by an
                               algorithm to run as a
                               function of the length of the
                               input. </li><br>
                               <li>
                               Recall that suppose our input is an array
                               of N elements, and our
                               algorithm iterates through
                               the array once, time
                               complexity will be O(N). If I
                               run two embedded loops to
                               traverse the array N times,
                               time complexity will be O(N<sup>2</sup>).
                               </li>
                            </ul>
                            </p>
                        </div>
                    </div>
                </div>                
                <div class="quiz" title="Pre-test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>                   
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of these best describes an array?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) A data structure that shows a hierarchical behavior</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Container of objects of similar types</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Container of objects of mixed types</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) All of the mentioned</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>An array is a data
                                       structure, which can
                                       store a fixed-size
                                       collection of elements
                                       of the same data type.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. What is the complexity of insertion at any point in an array?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N^2)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(NLogN)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of these</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Taking a general
                                       example,inserting
                                       into the middle of
                                       an array, you have
                                       to shift all the
                                       elements after that
                                       element, so the
                                       complexity for
                                       insertion in that
                                       case is O(n).  Worst
                                       case would be when
                                       you have to insert
                                       at the starting of
                                       the array,you will
                                       need to move n
                                       elements
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. What does it mean
                                        when we say that an
                                        algorithm X is
                                        asymptotically more
                                        efficient than Y?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) X will always be a better choice for small inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) X will always be a better choice for large inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Y will always be a better choice for small inputs</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) X will always be a better choice for all inputs</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Performance could be
                                       similar for small
                                       inputs, but definitely
                                       better for larger inputs
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. int a = 0, b = 0; <br>
                                        for (i = 0; i &lt; N; i++) {<br>
                                        a = a + rand();<br>
                                        }<br>
                                        for (j = 0; j &lt; M; j++) {<br>
                                        b = b + rand();<br>
                                        }<br>
                                        What is the time and space complexity for the above code?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(N * M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N + M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(N + M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) O(N * M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The first loop runs
                                       for O(n) time, second
                                       loop runs for O(m).
                                       Constant extra space
                                       is used for 2
                                       variables a and b,
                                       hence O(1) space.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>
            <div class="lu" title="Selection Sort">
                <div class="longt">
                    <h2 class="hlongt">Selection Sort Algorithm</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>15 minutes</p>
                        </div>
                    </div>
                    <div class="art req" title="Selection Sort Concept">
                        <div class="longt">
                            <h2 class="hlongt">Selection Sort Concept</h2>
                        </div>
                        <div class="description">
                            <p>Video for Selection Sort</p>
                        </div>
                    </div>
                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will learn about:</p>
                            <ul>
                                <li>Gain the intuition for Selection Sort</li>
                                <li>Learn about the Selection Sort algorithm</li>
                                <li>Practice the algorithm with step by step feedback</li>
                                <li>Perform exercises for obtaining clarity of concept</li>
                                <li>Test your conceptual understanding with a short quiz</li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="task" title="Selection Sort Algorithm">
                    <div class="longt">
                        <h2 class="hlongt">Understanding the Selection Sort Algorithm</h2>
                    </div>
                    <div class="art txt" title="Basic Intuition">
                        <div class="longt">
                            <h2 class="hlongt">How can we sort an array?</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                In Selection Sort, we take
                                the simplest, most intuitive
                                approach to sort an
                                array. Choose the smallest
                                number, place it in the
                                first position. Then choose
                                the next smallest number out
                                of the remaining elements,
                                and place it in the second
                                position and so on till the
                                end!
                            </p>      
                        </div>
                    </div>
                    <div class="art req" title="Selection Sort Intuition">
                        <div class="longt">
                            <h2 class="hlongt">Intuition Behind the Algorithm</h2>
                        </div>
                        <div class="description">
                            <p>Image shows the basic intuition</p>
                        </div>
                    </div>
                    <div class="art txt" title="Concept">
                        <div class="longt">
                            <h2 class="hlongt">Selection Sort Concept</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Now that we have understood
                                the basic intuition behind
                                this algorithm, let's see
                                how we can perform it in a
                                systematic way :
                                <br><br>
                                We will perform N-1
                                iterations on the array (N
                                is the number of elements in
                                the array). In iteration i
                                (1&le;i&le;N-1):
                            </p>
                            <ul>
                                <li>
                                    We will traverse the
                                    array from the i<sup>th</sup> index
                                    to the end and find
                                    the smallest number
                                    among these
                                    elements.  Note that
                                    if there are two
                                    smallest elements of
                                    the same value, we
                                    choose the one with
                                    the lower index.
                                </li>
                                <li>
                                    We will swap this
                                    smallest element
                                    with the i<sup>th</sup>
                                    element. 
                                </li>
                                <li>Hence at the end of
                                    the i<sup>th</sup> iteration,
                                    we have found the i<sup>th</sup> smallest
                                    number, and placed it at
                                    the i<sup>th</sup> position in the array!
                                </li>
                            </ul>
                            <p>
                                In the (N-1)<sup>th</sup> iteration,
                                we will place the (N-1)<sup>th</sup> smallest
                                element, which is the 2nd
                                largest element in the
                                array, at the second last
                                position. This will leave us
                                with one element which would
                                already be at its correct
                                place.This completes our
                                sorting!
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Selection Sort Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Selection Sort Algorithm</h2>
                        </div>
                        <div class="description">
                            Selection Sort Algorithm picture
                        </div>
                    </div>
                    <div class="art txt" title="Consolidated Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Consolidated Algorithm for Selection Sort </h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Given an array of N elements,
                                run N-1 iterations.
                                <br>
                                In iteration i (1&le;i&le;N-1):  
                            </p>
                            <ul>
                                <li>
                                    Find the smallest
                                    element with the least
                                    index, such that <b>index&le;i&le;N-1</b>.
                                </li>
                                <li>
                                    Swap the smallest
                                    element found with
                                    element at index <b>i</b>.
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="task" title="Selection Sort Demo">
                    <div class="longt">
                        <h2 class="hlongt">Demonstration for Selection Sort</h2>
                    </div>
                    <div class="art req" title="Selection Sort Demo">
                        <div class="longt">
                            <h2 class="hlongt">Demo : Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user can understand how Selection Sort works
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Selection Sort Practice">
                    <div class="longt">
                        <h2 class="hlongt">Step by Step Practice for Selection Sort</h2>
                    </div>
                    <div class="art req" title="Practice : Selection Sort">
                        <div class="longt">
                            <h2 class="hlongt">Practice : Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where
                               user can practice the Selection Sort algorithm
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Selection Sort Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Hands-on Exercise for Selection Sort</h2>
                    </div>
                    <div class="art req" title="Exercise : Selection Sort">
                        <div class="longt">
                            <h2 class="hlongt">Exercise : Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where user can generate questions and solve them, and then check the answers.
                                Ideas : find Kth largest/smallest element using Selection Sort etc
                            </p>
                        </div>
                    </div>
                </div>
                <div class="quiz" title="Selection Sort Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Revision Quiz for Selection Sort</h2>
                    </div>                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Maximum number of
                                       comparisons required for
                                       one iteration on an
                                       array of size 5?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 4</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 5</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) 3</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) 6</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Maximum number of
                                       comparisons will occur
                                       in the first iteration <br>
                                       To find the minimum
                                       in the whole list,
                                       you do a comparison
                                       with each element,
                                       hence 5  
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Which element
                                       reaches its correct
                                       position at the end of
                                       the 1st iteration?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) Smallest element</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Largest element</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Middle element</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) No element</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Selection Sort
                                       chooses the minimum(in
                                       the list) and replaces
                                       it with the first number
                                       in its 1st iteration 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. When do we swap two elements in Selection Sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) At the start of an iteration</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) At the end of an iterations</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) As soon as we find a minimum to update</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Middle of the iteration</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>In one iteration,
                                       Selection Sort finds
                                       the minimum in the
                                       current list and then
                                       swaps it with the
                                       first element of that
                                       window.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>
            <div class="lu" title="Analysis">
                <div class="longt">
                    <h2 class="hlongt">Analysis of Selection Sort</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    <div class="art req" title="Analysis of Selection Sort">
                        <div class="longt">
                            <h2 class="hlongt">Analysis of Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Time complexity of Selection Sort is explained</p>
                        </div>
                    </div>
                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will be learning about :</p>
                            <ul>
                                <li>
                                    <b>Time and Space
                                    Complexity</b> : We will
                                    learn about the running
                                    time of one iteration,
                                    and then extend it to N
                                    iterations to complete
                                    the sorting process.
                                </li>
                                <li>
                                    <b>Stable Sort</b> : We
                                    will learn about
                                    stability of sorting
                                    algorithms. Then we will
                                    see how Selection Sort
                                    is a stable sort.
                                </li>
                                <li>
                                    <b>Comparison with other
                                    algorithms</b> : We will
                                    compare Selection Sort
                                    with other sorting
                                    algorithms and see in
                                    which situations
                                    Selection Sort is the
                                    optimal/not optimal
                                    approach to take.
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="task" title="Time and Space Complexity">
                    <div class="longt">
                        <h2 class="hlongt">Time and Space Complexity of Selection Sort</h2>
                    </div>
                    <div class="art txt" title="Time Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Running Time of Selection Sort</h2>
                        </div>
                        <div class="art-body">
                            <p>Lets assume that we are
                               sorting <b>N</b> elements of
                               a given array using Selection
                               Sort.
                            </p>
                            <ul>
                                <li>
                                    To complete one
                                    iteration, we traverse a
                                    part of the array (from
                                    index i to the end) <b>exactly once</b> (while
                                    keeping track of the
                                    smallest element
                                    encountered so
                                    far). Since the longest
                                    length we ever traverse
                                    in any given iteration
                                    is N (in the first
                                    iteration when i=1 ->
                                    from first to last
                                    element), time
                                    complexity of completing
                                    one iteration is <b>O(N)</b>.
                                </li>
                                <li>
                                    In Selection Sort, we
                                    run N iterations, each
                                    of which takes O(N)
                                    time. Hence overall time
                                    complexity becomes
                                    O(N*N).
                                </li>
                                <li>
                                    Note that even if array
                                    is fully sorted
                                    initially, Selection
                                    Sort will take O(N<sup>2</sup>)
                                    time to complete, just
                                    as it will take for a
                                    reverse sorted or
                                    randomly sorted array.
                                </li>
                            </ul>
                        </div>
                    </div>
                    <div class="art req" title="Demo : Selection Sort Time Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Time complexity of Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Interactive artefact where
                               user can see how time
                               complexity is O(n2)
                            </p>
                        </div>
                    </div>
                    <div class="art txt" title="Space Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Space Complexity of Selection Sort</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                While swapping two elements,
                                we need some extra space to
                                store temporary
                                values. Other than that, the
                                sorting can be done
                                in-place. Hence space
                                complexity is <b>O(1) </b> or <b>
                                constant space</b>.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Stability of Selection Sort">
                    <div class="longt">
                        <h2 class="hlongt">Stability of Selection Sort</h2>
                    </div>
                    <div class="art txt" title="Stable Sort">
                        <div class="longt">
                            <h2 class="hlongt">What is a Stable Sort Algorithm?</h2>
                        </div>
                        <div class="art-body">
                            <p>A sorting algorithm is said
                               to be <b>stable</b> if two
                               objects with equal keys
                               appear in the same order in
                               sorted output as they appear
                               in the input unsorted
                               array. For example, look at
                               the picture below. The
                               unsorted array has two
                               elements with value 23. Note
                               the order of both these
                               elements in the stable and
                               unstable sorted arrays.
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Stable and Unstable sort">
                        <div class="longt">
                            <h2 class="hlongt">Stable and Unstable sort</h2>
                        </div>
                        <div class="description">
                            <p>Image shows scenarios to swap and not swap</p>
                        </div>
                    </div>
                    <div class="art txt" title="Stability of Selection Sort">
                        <div class="longt">
                            <h2 class="hlongt">Is Selection Sort Stable?</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Yes, Selection Sort is a
                                stable sorting
                                algorithm. When looking for
                                the smallest element, we
                                choose the element with
                                lower index incase there are
                                two or more equal elements
                                that are the smallest
                                elements in the array. This
                                makes sure that we preserve
                                the relative ordering
                                between equal elements.
                            </p>
                            <p>
                                Look at the picture below
                                and keep and eye out for the
                                ordering of <b>23</b> and <b>23*</b>. Note
                                how the original order of
                                these elements is retained
                                throughout the sorting
                                process. The relative
                                positioning of <b>23</b> and <b>23*</b>
                                does not change in the
                                sorted output.
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Stable Selection Sort">
                        <div class="longt">
                            <h2 class="hlongt">Stability of Selection Sort</h2>
                        </div>
                        <div class="description">
                            <p>Image shows stabilty of Selection Sort</p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Comparison with other algorithms">
                    <div class="longt">
                        <h2 class="hlongt">Comparison with other algorithms</h2>
                    </div>
                    <div class="art req" title="Comparison Graph">
                        <div class="longt">
                            <h2 class="hlongt">Graph : Time Complexities of Sorting Algorithms</h2>
                        </div>
                        <div class="description">
                            <p>comparison</p>
                        </div>
                    </div>
                    <div class="art txt" title="Comparison Table">
                        <div class="longt">
                            <h2 class="hlongt">Comparison with other sorting algorithms</h2>
                        </div>
                        <div class="art-body">
                            <table>
                                <tbody>
                                    <tr>
                                        <th style="text-align:center" colspan="1">Algorithm</th>
                                        <th style="text-align:center" colspan="3">Time</th>
                                        <th style="text-align:center" colspan="2">Features</th>
                                    </tr>
                                    <tr id="headings">
                                        <td><strong>Sort</strong></td>
                                        <td><strong>Average</strong></td>
                                        <td><strong>Best</strong></td>
                                        <td><strong>Worst</strong></td>
                                        <td><strong>Space</strong></td>
                                        <td><strong>Stability</strong></td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Selection
                                            Sort</a>
                                        </td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black">Modified
                                            Selection Sort</a>
                                        </td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Selection
                                            Sort</a>
                                        </td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Insertion
                                            Sort</a>
                                        </td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Heap
                                            Sort</a>
                                        </td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>Constant</td>
                                        <td>Unstable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Merge
                                            Sort</a>
                                        </td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>Depends</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black" >Quick Sort</a></td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <div class="quiz" title="Analysis Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Revision Quiz for Analysis</h2>
                    </div>                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. What is the time complexity of Selection Sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Average case O(n<sup>2</sup>))</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Best case O(n<sup>2</sup>)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Worst case O(n<sup>2</sup>)</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) All the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Selection Sort in its
                                       best implementation
                                       performs N + (N-1) +
                                       (N-2) .... 1
                                       operations which is
                                       O(n<sup>2</sup>) 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Is Selection Sort stable?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) Yes</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) No</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Depends</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) Can't say</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Selection Sort is stable as explained earlier.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. Compare best case
                                       time complexities of
                                       Selection Sort and
                                       Bubble Sort
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Equal</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Bubble sort is better</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Selection Sort is better</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Unequal</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Bubble sort: Best
                                       case O(N) Selection
                                       Sort: Best case O(N<sup>2</sup>)
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>
            <div class="lu" title="Post Test">
                <div class="longt">
                    <h2 class="hlongt">Post Test of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Quiz</h2>
                        </div>
                        <div class="art-body">
                            <p>Post Test includes questions
                               on entire experiment
                               concepts. Read the questions
                               in the quiz section and
                               select the correct option
                               from the ones
                               provided. Please note that
                               some questions may have more
                               than one correct response.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="quiz" title="Post-test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Post test quiz</h2>
                    </div>                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which among the
                                       following is an
                                       advantage of
                                       Selection Sort over
                                       other sorting
                                       algorithms?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Faster than others</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) It does not require additional storage spaces</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Very efficient</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Suitable for long lists</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p> Selection Sort is an
                                        in-place sort, so it
                                        doesn't require any
                                        additional storage
                                        space.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. What is the average and best case time complexity of Selection Sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(n<sup>2</sup>), O(n<sup>2</sup>)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(n<sup>2</sup>), O(n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(n<sup>2</sup>), O(nlogn)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of these</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Selection Sort in its
                                        best implementation does
                                        n + (n-1) + (n-2) ... 1
                                        steps which is O(n<sup>2</sup>)  
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. Given array =
                                       {11,12,13,10,9}. Number
                                       of iterations
                                       required by Bubble
                                       Sort and Selection
                                       Sort are?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 5,4</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 4,4</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) 4,6</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) 5,5</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Bubble Sort: The array will be sorted at the end of the 4th iteration but one more iteration will be run and on finding no swaps the sort will terminate. So, 4+1 = 5<br>
                                        Selection Sort always takes "N-1" iterations
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. What are the
                                       correct intermediate
                                       steps when you
                                       perform Selection
                                       Sort on [2, 7, -3,
                                        5]?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) [-3, 2, 7, 5] -> [-3, 2, 5, 7]</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) [-3, 7, 2, 5] -> [-3, 2, 7, 5] -> [-3, 2, 5, 7]</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) [-3, 7, 5, 2] -> [-3, 2, 5, 7]</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) [-3, 7, 2, 5] -> [-3, 5, 2, 7] -> [-3, 2, 5, 7]</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Find the minimum in each window and swap with the first element in that window
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question5">
                                <div class="art-body">
                                    <p>Q5. Predict the structure of Selection Sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) One Loop</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Two loops</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Two lops in a loop</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) Loop inside a loop</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Selection Sort
                                       involves finding the
                                       minimum out of the
                                       given list O(N) times<br>
                                       This requires nested
                                       loops   
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>
            
            <div class="lu" title="Further Readings/References">
                <div class="longt">
                    <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Explore">
                        <div class="longt">
                            <h2 class="hlongt">Explore More About Selection Sort</h2>
                        </div>
                        <div class="art-body">
                            <p>You can explore more about
                               Selection Sort experiment
                               through following resources:
                            </p>
                            <br>
                            <b>Useful Links :</b>
                            <ul>
                                <li><a href="https://visualgo.net/bn/sorting?slide=7">Selection Sort Visualisation</a></li>
                                <li><a href="https://www.geeksforgeeks.org/selection-sort/">Coding implementation of Selection Sort</a></li>
                            </ul>
                            <b>Quizzes :</b> 
                            <ul>
                                <li><a href="https://www.geeksforgeeks.org/quiz-selectionsort-gq/">MCQ Quiz for Selection Sort</a></li>
                                <li><a href="https://www.geeksforgeeks.org/algorithms-gq/searching-and-sorting-gq/">Combined Quiz for Sorting Algorithms</a></li>
                                <li><a href="https://www.sanfoundry.com/data-structure-questions-answers-selection-sort/">Online Quiz for Selection Sort</a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>

            <!--div class="lu" title="Feedback">
                <div class="longt">
                    <h2 class="hlongt">Feedback of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Feedback Form">
                        <div class="longt">
                            <h2 class="hlongt">Feedback Form of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <p>The experiment ends
                               here,thanks for
                               participating! Please fill up
                               the form.
                            </p>
                        </div>
                    </div>
                </div>
            </div-->
        </div>
        <script src="./js/loader.js"></script>
    </body>
</html>

